/*
 * RSH - Robte si hocičo
 *
 * Ktokoľvek a čokoľvek smie kopírovať, upravovať, zverejňovať,
 * používať, kompilovať, predávať a šíriť toto dielo
 * a všetky jeho časti v akejkoľvek podobe na akékoľvek účely,
 * komerčné a nekomerčné, bez akýchkoľvek obmedzení,
 * bez dodržiavania akýchkoľvek podmienok
 * a akýmikoľvek prostriedkami.
 *
 * Jeder und alles darf kopieren, bearbeiten, veröffentlichen,
 * verwenden, kompilieren, verkaufen und verbreiten dieses Werk
 * und alle seine Teile in irgendeiner Form für irgendeinen Zweck,
 * kommerziell und nichtkommerziell, ohne Beschränkungen,
 * ohne irgendwelche Bedingungen einzuhalten
 * und mit allen Mitteln.
 *
 * Anyone and anything may copy, edit, publish,
 * use, compile, sell and distribute this work
 * and all its parts in any form for any purpose,
 * commercial and non-commercial, without any restrictions,
 * without complying with any conditions
 * and by any means.
 */

#include <stdio.h>
#include <string.h>
#include <ctype.h>

#include "lexer.h"

/* Toto nie je fajn!--- */
static char hodnota[MAX_IDENT];
static int hodnotaIndex;

int lexerLex(FILE *f)
{
    char c;

    hodnota[0] = '\0';

    do {
        c = fgetc(f);
    } while (isspace(c));
    switch (c) {
        case EOF: return (END_OF_FILE);

        case '{': return (LBRACE);

        case '}': return (RBRACE);

        case '(': return (LPAREN);

        case ')': return (RPAREN);

        case ';': return (SEMIKOLON);

        case '-': return (MIINUS);

        case '~': return (TILDE);

        case '!':
            c = fgetc(f);
            if (c == '=') return (NOT_EQUAL);
            ungetc(c, f);
            return (LOG_NEG);

        case '+': return (PLUS);

        case '*': return (HVIEZDA);

        case '/': return (LOMKA);

        case '&':
            c = fgetc(f);
            if (c == '&') return (LOG_AND);
            ungetc(c, f);
            return (AMPERSAND);

        case '|':
            c = fgetc(f);
            if (c == '|') return (LOG_OR);
            ungetc(c, f);
            break;

        case '=':
            c = fgetc(f);
            if (c == '=') return (EQUAL);
            ungetc(c, f);
            return (ASSIGN);

        case '<':
            c = fgetc(f);
            if (c == '=') return (LESS_EQUAL);
            ungetc(c, f);
            return (LESS);

        case '>':
            c = fgetc(f);
            if (c == '=') return (GREATER_EQUAL);
            ungetc(c, f);
            return (GREATER);

        case '?': return (OTAAZNIK);

        case ':': return (KOLON);

        case ',': return (CSHIARKA);
    }

    hodnotaIndex = 0;

    if (isdigit(c))
    {
        while (isdigit(c))
        {
            hodnota[hodnotaIndex] = c;
            hodnotaIndex++;
            c = fgetc(f);
        }
        hodnota[hodnotaIndex] = '\0';
        ungetc(c, f);
        return (INTLIT);
    }
    if (isalpha(c))
    {
        while (isalnum(c) || c == '_')
        {
            hodnota[hodnotaIndex] = c;
            hodnotaIndex++;
            c = fgetc(f);
        }
        hodnota[hodnotaIndex] = '\0';
        ungetc(c, f);

        if (strcmp(hodnota, "if") == 0) return (IF);
        if (strcmp(hodnota, "else") == 0) return (ELSE);

        if (strcmp(hodnota, "for") == 0) return (FOR);
        if (strcmp(hodnota, "while") == 0) return (WHILE);
        if (strcmp(hodnota, "do") == 0) return (DO);
        if (strcmp(hodnota, "break") == 0) return (BREAK);
        if (strcmp(hodnota, "continue") == 0) return (CONTINUE);

        if (strcmp(hodnota, "int") == 0) return (INT);
        if (strcmp(hodnota, "return") == 0) return (RETURN);

        return (IDENT);
    }

    return (ZHIADEN_TOK);
}

char *lexerHodnota()
{
    return (hodnota);
}

void lexerTest(int tok)
{
    switch (tok) {
        case END_OF_FILE: printf("END_OF_FILE\n"); break;

        case LBRACE: printf("LBRACE\n"); break;

        case RBRACE: printf("RBRACE\n"); break;

        case LPAREN: printf("LPAREN\n"); break;

        case RPAREN: printf("RPAREN\n"); break;

        case SEMIKOLON: printf("SEMIKOLON\n"); break;

        case INTLIT: printf("INTLIT\n"); break;

        case HVIEZDA: printf("HVIEZDA\n"); break;

        case PLUS: printf("PLUS\n"); break;

        case CSHIARKA: printf("CSHIARKA\n"); break;

        case LOG_AND: printf("LOG_AND\n"); break;

        case LOG_OR: printf("LOG_OR\n"); break;

        case ASSIGN: printf("ASSIGN\n"); break;

        case INT: printf("INT\n"); break;

        case RETURN: printf("RETURN\n"); break;

        case IDENT: printf("IDENT\n"); break;

        default: printf("Tento tok chyyba v lexerTest()\n"); break;
    }
}
