/*
 * RSH - Robte si hocičo
 *
 * Ktokoľvek a čokoľvek smie kopírovať, upravovať, zverejňovať,
 * používať, kompilovať, predávať a šíriť toto dielo
 * a všetky jeho časti v akejkoľvek podobe na akékoľvek účely,
 * komerčné a nekomerčné, bez akýchkoľvek obmedzení,
 * bez dodržiavania akýchkoľvek podmienok
 * a akýmikoľvek prostriedkami.
 *
 * Jeder und alles darf kopieren, bearbeiten, veröffentlichen,
 * verwenden, kompilieren, verkaufen und verbreiten dieses Werk
 * und alle seine Teile in irgendeiner Form für irgendeinen Zweck,
 * kommerziell und nichtkommerziell, ohne Beschränkungen,
 * ohne irgendwelche Bedingungen einzuhalten
 * und mit allen Mitteln.
 *
 * Anyone and anything may copy, edit, publish,
 * use, compile, sell and distribute this work
 * and all its parts in any form for any purpose,
 * commercial and non-commercial, without any restrictions,
 * without complying with any conditions
 * and by any means.
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>

#include "lexer.h"
#include "parser.h"
#include "genk.h"

const char zaaklad_priikazu[] = "gcc ";

int main(int argc, char **argv)
{
    char *cielh_dnu;
    char *cielh_von;

    if (argc <= 1)
    {
        printf("zck: Zhiaden vstup!\n");
        return (0);
    }

    if (argc > 2)
    {
        printf("zck: Privelha argumentov!\n");
        return (0);
    }

    cielh_dnu = argv[1];
    if (strcmp(cielh_dnu + (strlen(cielh_dnu) - 2), ".c") != 0)
    {
        printf("zck: Vstupnyy suubor %s nemaa vhodnuu priiponu (.c)!\n",
               cielh_dnu);
        return (0);
    }

    printf("zck: Kompiluje sa praave suubor %s\n", cielh_dnu);
    {
        FILE *f;
        AST *translationUnit;

        f = fopen(cielh_dnu, "r");
        if (f == NULL)
        {
            printf("Chyba v main(): Nepodarilo sa otvorith suubor %s\n",
                   cielh_dnu);
            return (0);
        }

        /* Lexer bezhi spolu s parserom. */
        printf("Parsovanie\n");
        translationUnit = parserTranslationUnit(f);
        printf("Parsovanie hotovee!\n");

        fclose(f);

        cielh_von = malloc(strlen(cielh_dnu) + 1);
        if (cielh_von == NULL)
        {
            printf("Nepodarilo sa alokovath pameth"
                   " pre meno vyystupneeho suuboru\n");
            return (0);
        }
        strcpy(cielh_von, cielh_dnu);
        cielh_von[strlen(cielh_von) - 1] = 's';

        f = fopen(cielh_von, "w");
        if (f == NULL)
        {
            printf("Chyba v main(): Nepodarilo sa vytvorith suubor %s\n",
                   cielh_von);
            return (0);
        }

        printf("Generovanie koodu\n");
        genkGeneruj(translationUnit, f);
        printf("Generovanie koodu hotovee!\n");

        fclose(f);

        printf("Volanie assemblera a linkera\n");
        {
            char *priikaz = malloc(strlen(zaaklad_priikazu)
                                   + strlen(cielh_von) + 1);

            if (priikaz == NULL)
            {
                printf("Nepodarilo sa alokovath pameth"
                       " pre priikaz pre assembler a linker\n");
                return (0);
            }
            strcpy(priikaz, zaaklad_priikazu);
            strcat(priikaz, cielh_von);

            free(cielh_von);

            system(priikaz);

            free(priikaz);
        }
        printf("Hotovo!\n");
    }
    printf("Koniec!\n");

    return (0);
}
